#include "main.h"
#include "alarm.h"

void init_alarms()
{
	//	Definitionen der einzelnen Klingeltöne

	//	Kurzer Einzelton
	alarm_ringtone[0][0] = 100;	//	non
	alarm_ringtone[0][1] = 1000;	//	noff
	alarm_ringtone[0][2] = 1;	//	ton
	alarm_ringtone[0][3] = 3;	//	toff

	load_alarms();

	alarm_tone = 0;	//	Klingelton (0 = AUS)
}

void wipe_alarms()
{
	for (unsigned int i = 0; i < 10; i++)
	{
		eeprom_busy_wait(); eeprom_write_byte((unsigned char *)(i * 3 + 0), 6 + i);
		eeprom_busy_wait(); eeprom_write_byte((unsigned char *)(i * 3 + 1), 0);
		eeprom_busy_wait(); eeprom_write_byte((unsigned char *)(i * 3 + 2), 0);
	}
}

void load_alarms()
{
	//	Alarme aus EEPROM laden
	for (unsigned char i = 0; i < 10; i++)
	{
		for (unsigned char j = 0; j < 3; j++)
		{
			eeprom_busy_wait();
			alarm[i][j] = eeprom_read_byte((unsigned char *)(i * 3 + j));
		}
	}
}

void save_alarms()
{
	//	Alarme im EEPROM speichern
	for (unsigned char i = 0; i < 10; i++)
	{
		for (unsigned char j = 0; j < 3; j++)
		{
			eeprom_busy_wait();
			eeprom_write_byte((unsigned char *)(i * 3 + j), alarm[i][j]);
		}
	}
}
