#include "main.h"
#include "display.h"

void init_display()
{
	//	Displaycodes laden

	//	Ziffern 0 bis 9
	display_character[0][0] = 0b111011; display_character[0][1] = 0b01000;
	display_character[1][0] = 0b000001; display_character[1][1] = 0b01000;
	display_character[2][0] = 0b110111; display_character[2][1] = 0b00000;
	display_character[3][0] = 0b100111; display_character[3][1] = 0b01000;
	display_character[4][0] = 0b001101; display_character[4][1] = 0b01000;
	display_character[5][0] = 0b101110; display_character[5][1] = 0b01000;
	display_character[6][0] = 0b111110; display_character[6][1] = 0b01000;
	display_character[7][0] = 0b000011; display_character[7][1] = 0b01000;
	display_character[8][0] = 0b111111; display_character[8][1] = 0b01000;
	display_character[9][0] = 0b101111; display_character[9][1] = 0b01000;

	//	Strich
	display_character[10][0] = 0b000100; display_character[10][1] = 0b00000;

	//	A, L
	display_character[11][0] = 0b011111; display_character[11][1] = 0b01000;
	display_character[12][0] = 0b111000; display_character[12][1] = 0b00000;

	//	N, F
	display_character[13][0] = 0b011011; display_character[13][1] = 0b01000;
	display_character[14][0] = 0b011110; display_character[14][1] = 0b00000;

	//	r, E
	display_character[15][0] = 0b010100; display_character[15][1] = 0b00000;
	display_character[16][0] = 0b111110; display_character[16][1] = 0b00000;

	//	t, P
	display_character[17][0] = 0b111100; display_character[17][1] = 0b00000;
	display_character[18][0] = 0b011111; display_character[18][1] = 0b00000;

	//	Beim Einschalten leeres Display
	display(-1, -1, -1, -1);
}

//	Eine Uhrzeit ausgeben
void display_time(char hours, char minutes)
{
	//	Zeitwerte in Ziffern umwandeln
	char char1 = hours / 10;
	char char2 = hours - char1 * 10;
	char char3 = minutes / 10;
	char char4 = minutes - char3 * 10;

	//	Keine führende Null anzeigen
	if (char1 == 0) char1 = -1;

	display(char1, char2, char3, char4);
}

//	Display laden
void display(char char1, char char2, char char3, char char4)
{
	display_content[0][0] = char1;
	display_content[1][0] = char2;
	display_content[2][0] = char3;
	display_content[3][0] = char4;
}

//	Punkte im Display
void dots(char dot1, char dot2, char dot3, char dot4)
{
	display_dot[0] = dot1;
	display_dot[1] = dot2;
	display_dot[2] = dot3;
	display_dot[3] = dot4;
}

//	Stelle im Display blinken lassen
void display_blink_on(unsigned char num)
{
	display_content[num][1] = 1;	//	Blinkstatus
	display_content[num][2] = 1;	//	Blinken an
}

//	Blinken einer Stelle im Display ausschalten
void display_blink_off(unsigned char num)
{
	display_content[num][1] = 0;	//	Blinkstatus
	display_content[num][2] = 0;	//	Blinken aus
}

//	Anzeigeeigenschaften
void set_display_mode(char mode)
{
	if (mode == 0)
	//	Menü
	{
		led_green = 0;
		led_red = 1;
		display_dot_blink = 0;
		display_fade = 0;
		display_brightness = 100;
		dots(0, 0, 0, 0);
	}
	else if (mode == 1)
	//	Normal
	{
		led_green = 1;
		led_red = 0;
		display_dot_blink = 2;
		display_fade = 0;
		display_brightness = 100;
		dots(0, 0, 0, 0);
	}
	else if (mode == 2)
	//	Schlaf 1
	{
		led_green = 0;
		led_red = 0;
		display_dot_blink = 0;
		display_fade = 1;
		dots(0, 1, 0, 0);
	}
	else if (mode == 3)
	//	Schlaf 2
	{
		led_green = 0;
		led_red = 0;
		display_dot_blink = 0;
		display_fade = 0;
		display_brightness = 20;
		dots(0, 1, 0, 0);
	}
}
