#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

#include "display.h"
#include "user.h"
#include "alarm.h"
#include "timer0.h"
#include "timer1.h"

#define F_CPU 4608000UL

#define TRUE	0
#define FALSE	1

#define	set_bit(var, bit)	((var) |= (1 << (bit)))
#define	clear_bit(var, bit)	((var) &= (unsigned)~(1 << (bit)))

void init_main();



#define DCF77_COUNTER_THRESHOLD	8
#define DCF77_LEVEL_THRESHOLD	11
#define DCF77_SYNC_THRESHOLD	107


struct dcf77
{
	unsigned char mesz;
	unsigned char leapsec;
	unsigned char minute;
	unsigned char hour;
	unsigned char mday;
	unsigned char wday;
	unsigned char month;
	unsigned char year;
} dcf77;

#define alarm_ringtone_max 4

//	Alarm
//	[Nummer] [0 = Stunde, 1 = Minute, 2 = (0 = Alarm aus, 1 = Alarm an)]
unsigned char alarm[10][3];

long alarm_ringtone[alarm_ringtone_max][4], alarm_ringtone_dummy[alarm_ringtone_max][4];

char alarm_tone, alarm_stage;

char display_content[4][3], display_dot[4];
char time_counter;
char display_dot_blink, display_fade;

//	Zählen die Tastdauer der beiden Taster (10ms Auflösung)
//	++ bei gedrücktem Taster und -- bei nicht gedrücktem Taster
//	(min. 0, max. 65535)
unsigned int button_back_counter, button_forth_counter;

int display_character[19][2], display_multiplexer;
int display_pwm_counter, display_brightness;

unsigned char led_green, led_red;

char seconds, minutes, hours;

#endif
