#include "main.h"
#include "timer0.h"

//	Display-Interrupt (Multiplexing), Helligkeitsregelung (PWM) und Soundausgabe
ISR(TIMER0_OVF_vect)
{



	//	Soundausgabe
	if (alarm_tone > 0)
	{

		if (alarm_ringtone_dummy[(alarm_tone - 1)][0] > 0)
		{
			//	Ton an...
			led_red = 1;

			//	...Display aus
			display_brightness = 0;
			led_red = 0;
			led_green = 0;
			PORTC = (1 << 4) * 0 + (1 << 5) * 0;

			if (alarm_ringtone_dummy[(alarm_tone - 1)][2] > 0)
			{
				alarm_ringtone_dummy[(alarm_tone - 1)][2]--;
				set_bit(PORTD, 0);
			}
			else if (alarm_ringtone_dummy[(alarm_tone - 1)][3] > 0)
			{
				alarm_ringtone_dummy[(alarm_tone - 1)][3]--;
				clear_bit(PORTD, 0);
			}
			else
			{
				//	On- und Off-Time-Zähler wieder auffüllen
				for (unsigned char i = 0; i < alarm_ringtone_max; i++)
				{
					alarm_ringtone_dummy[i][2] = alarm_ringtone[i][2];
					alarm_ringtone_dummy[i][3] = alarm_ringtone[i][3];
				}

				//	Auf in die nächste Runde...
				alarm_ringtone_dummy[(alarm_tone - 1)][0]--;
			}


		}
		else if (alarm_ringtone_dummy[(alarm_tone - 1)][1] > 0)
		{
			//	Ton aus...
			led_red = 0;
			clear_bit(PORTD, 0);

			//	...Display an
			display_brightness = 100;
			led_red = 1;
			led_green = 1;

			if (alarm_ringtone_dummy[(alarm_tone - 1)][2] > 0)
			{
				alarm_ringtone_dummy[(alarm_tone - 1)][2]--;
			}
			else if (alarm_ringtone_dummy[(alarm_tone - 1)][3] > 0)
			{
				alarm_ringtone_dummy[(alarm_tone - 1)][3]--;
			}
			else
			{
				//	On- und Off-Time-Zähler wieder auffüllen
				for (unsigned char i = 0; i < alarm_ringtone_max; i++)
				{
					alarm_ringtone_dummy[i][2] = alarm_ringtone[i][2];
					alarm_ringtone_dummy[i][3] = alarm_ringtone[i][3];
				}

				//	Auf in die nächste Runde
				alarm_ringtone_dummy[(alarm_tone - 1)][1]--;
			}

		}
		else
		{
			//	Von vorne beginnen, alle Dummy-Variablen wieder "auffüllen"
			for (unsigned char i = 0; i < alarm_ringtone_max; i++)
			{
				for (unsigned char j = 0; j < 4; j++) alarm_ringtone_dummy[i][j] = alarm_ringtone[i][j];
			}
		}


	}



	//	Display an
	if ((display_pwm_counter > 0) && (display_pwm_counter < display_brightness))
	{
		//	Licht aus...
		PORTC = (1 << 4) * led_green + (1 << 5) * led_red;

		//	Zeichen laden
		if ((display_content[display_multiplexer][0] > -1) && (display_content[display_multiplexer][2] == 0))
		{
			PORTB = display_character[(unsigned char)display_content[display_multiplexer][0]][0];
			PORTD = display_character[(unsigned char)display_content[display_multiplexer][0]][1] | 0b01000110 | (PIND & 1);
		}
		else
		{
			PORTB = 0b000000;
			PORTD =	0b01000110 | (PIND & 1);
		}

		//	Punkte im Display
		PORTD |= (1 << 4) * display_dot[display_multiplexer] | (PIND & 1);

		//	...Spot an!
		PORTC = (1 << display_multiplexer) + (1 << 4) * led_green + (1 << 5) * led_red;

		//	Nächste Anzeige auswählen
		if (display_multiplexer < 3) display_multiplexer++; else display_multiplexer = 0;
	}

	//	Display aus
	if ((display_pwm_counter >= display_brightness) && (display_pwm_counter <= 100))
	{
		PORTC = (1 << 4) * led_green + (1 << 5) * led_red;
	}

	if (display_pwm_counter < 99) display_pwm_counter++; else display_pwm_counter = 0;



}
