#include "main.h"
#include "timer1.h"

//	Zeit-Interrupt
ISR(TIMER1_COMPA_vect)
{
	time_counter++;

	if (((time_counter == 50) || (time_counter > 99)) || (display_dot_blink == 2))
	{
		//	Bei Bedarf Punkt blinken lassen
		if (display_dot_blink > 0)
		{
			if ((time_counter > 99) || (display_dot_blink > 1))
			{
				display_dot_blink = 1;
				dots(0, 1, 0, 0);
			}
			else
			{
				dots(0, 0, 0, 0);
			}
		}

		//	Bei Bedarf Displaysegmente Blinken lassen
		for (int i = 0; i < 4; i++)
		{
			if (display_content[i][1] == 1) display_content[i][2] ^= 1;
		}
	}

	if (time_counter > 99)
	{
		//	Zeitzähler löschen
		time_counter = 0;

		//	Sekunden
		if (seconds < 59)
		{
			seconds++;
		}
		else
		{
			seconds = 0;

			//	Minuten
			if (minutes < 59)
			{
				minutes++;
			}
			else
			{
				minutes = 0;

				//	Stunden
				if (hours < 23)
				{
					hours++;
				}
				else
				{
					hours = 0;
				}
			}
		}
	}



	//	Beide Taster entprellen

		//	Vorderer Taster
		if (!bit_is_set(PIND, 1))
		{
			if (button_forth_counter < 65535) button_forth_counter++;
		}
		else
		{
			if (button_forth_counter > 0) button_forth_counter--;
		}

		//	Hinterer Taster
		if (!bit_is_set(PIND, 2))
		{
			if (button_back_counter < 255) button_back_counter++;
		}
		else
		{
			if (button_back_counter > 0) button_back_counter--;
		}

	//	Display ein- und ausfaden
	if (display_fade == 1)
	{
		if (time_counter < 50)
		{
			display_brightness = (time_counter);
		}
		else
		{
			display_brightness = (100 - time_counter);
		}
	}
}
